#include<iostream>
using namespace std;

int main() {
	int n, m, k;
	string grzadka;
	vector<int> z, p, D;
	cin >> n >> m >> k;
	p.resize(k+1);
	D.resize(k+1);
	for(int i=1; i<=n; i++) {
		cin >> grzadka;
		z.clear();
		for(int j=0;j<m;j++) {
			if(grzadka[j]=='x') {
				z.push_back(j);
			}
		}
		int l = z.size();
		if(l==0) continue;
		for(int j=0; j<min(l, k+1); j++) {
			p[j] = MAX_INT;
			for(int s=0; s<=j; s++) {
				p[j] = min(p[j], z[l-1-j+s]-z[s]+1)
			}
		}
		for(int j=k; j>=0; j--) {
			D[j] += p[0];
			for(int s=1; s<=min(j, l); s++) {
				D[j] = min(D[j], D[j-s]+p[s]);
			}
		}
	}
	cout << D[k];
}
